## adios 1.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)
project(ADIOS_PROJECT)

SET_PROPERTY(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)

#set(LANGUAGE "" CACHE FILEPATH "")  #C/CXX/Fortran

#enable_language(${LANGUAGE})
#message(STATUS "CMAKE_${LANGUAGE}_COMPILER_WORKS = ${CMAKE_${LANGUAGE}_COMPILER_WORKS}")

include_directories(${PROJECT_SOURCE_DIR})
link_directories(${PROJECT_BINARY_DIR})
#message("${PROJECT_SOURCE_DIR}")

#set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR})

set(CMAKE_INSTALL_PREFIX $ENV{INSTALL_PREFIX} CACHE PATH "Prefix prepended to install directories" FORCE)
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix})
set(bindir ${exec_prefix}/bin)
#set(datadir ${prefix}/share)
set(libdir ${exec_prefix}/lib)
set(includedir ${prefix}/include)


if(DEFINED ENV{MACRODEFFLAG})
  set(MACRODEFFLAG $ENV{MACRODEFFLAG})
else()
  set(MACRODEFFLAG "-D")
endif()
message(STATUS "MACRODEFFLAG = ${MACRODEFFLAG}")

set(LIBS "")
set(CPPFLAGS "$ENV{CPPFLAGS}")
set(CFLAGS "$ENV{CFLAGS}")
set(EXTRA_CFLAGS "$ENV{EXTRA_CFLAGS}")
set(EXTRA_LIBS "$ENV{EXTRA_LIBS}")
######## file moved from initial_cache.cmake to indicate external library is used(ON) or not (OFF)######
if(DEFINED ENV{BUILD_WRITE})
  if("$ENV{BUILD_WRITE}" STREQUAL "") 
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE $ENV{BUILD_WRITE})
  endif()
  if(BUILD_WRITE)
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_WRITE ON CACHE BOOL "")
endif()

if(DEFINED ENV{BUILD_FORTRAN})
  if("$ENV{BUILD_FORTRAN}" STREQUAL "")
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN $ENV{BUILD_FORTRAN})
  endif()
  if(BUILD_FORTRAN)
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_FORTRAN ON CACHE BOOL "")
endif()

if(DEFINED ENV{skel_timing})
  if("$ENV{skel_timing}" STREQUAL "")
#    message("SKEL is not enabled")
    set(SKEL_TIMING 0)
  elseif("$ENV{skel_timing}" STREQUAL "ON")
    set(SKEL_TIMING 1)
  elseif("$ENV{skel_timing}" STREQUAL "on")
    set(SKEL_TIMING 1)
  elseif("$ENV{skel_timing}" STREQUAL "OFF")
    set(SKEL_TIMING 0)
  elseif("$ENV{skel_timing}" STREQUAL "off")
    set(SKEL_TIMING 0)
  else()
    set(SKEL_TIMING 0)
  endif()
  if(SKEL_TIMING)
    set(SKEL_HAVE_ADIOS_TIMING True)
  else()
    set(SKEL_HAVE_ADIOS_TIMING False)
  endif()
else()
  set(SKEL_HAVE_ADIOS_TIMING False)
#  message("SKEL is not enabled")
endif()
#message("SKEL_HAVE_ADIOS_TIMING is ${SKEL_HAVE_ADIOS_TIMING}")

if(DEFINED ENV{bgq})
  if("$ENV{bgq}" STREQUAL "")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "ON")
    set(HAVE_BGQ 1)
    set(BGQ ON CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "on")
    set(HAVE_BGQ 1)
    set(BGQ ON CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "OFF")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "Off")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  else()
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  endif()
else()
  set(HAVE_BGQ 0)
  set(BGQ OFF CACHE BOOL "")
endif()

if(DEFINED ENV{research_transports})
  if("$ENV{research_transports}" STREQUAL "")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "OFF")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "off")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "on")
    set(RESEARCH_TRANSPORTS 1)
    message("research_transports is enabled")
  elseif("$ENV{research_transports}" STREQUAL "ON")
    set(RESEARCH_TRANSPORTS 1)
    message("research_transports is enabled")
  else()
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  endif()
else()
  set(RESEARCH_TRANSPORTS 0)
  message("research_transports is NOT enabled")
endif()

set(MXML_DIR $ENV{MXML_DIR}  CACHE FILEPATH "path to mxml dir")

set(DATATAP OFF CACHE BOOL "")

set(NSSI OFF CACHE BOOL "")

if(DEFINED ENV{SEQ_NC_DIR})
  if("$ENV{SEQ_NC_DIR}" STREQUAL "")
    set(NETCDF OFF CACHE BOOL "")
  else()
    set(NETCDF ON CACHE BOOL "")
    set(NETCDF_DIR "$ENV{SEQ_NC_DIR}" CACHE FILEPATH "path to suquential NETCDF dir")
  endif()
else()
  set(NETCDF OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PAR_NC_DIR})
  if("$ENV{PAR_NC_DIR}" STREQUAL "")
    set(NC4PAR OFF CACHE BOOL "")
  else()
    set(NC4PAR ON CACHE BOOL "")
    set(NC4PAR_DIR "$ENV{PAR_NC_DIR}" CACHE FILEPATH "path to parallel NETCDFdir")
  endif()
else()
  set(NC4PAR OFF CACHE BOOL "")
endif()

#if(DEFINED ENV{PAR_NC_DIR} AND DEFINED ENV{PAR_NC_CLIB})
#  set(NC4PAR ON CACHE BOOL "")
#  set(NC4PAR_DIR $ENV{PAR_NC_DIR} CACHE FILEPATH "")
#  set(NC4PAR_CPPFLAGS "-I${NC4PAR_DIR}/include")
#  set(NC4PAR_LIBS $ENV{PAR_NC_CLIB} CACHE STRING "parallel netcdf")
#else()
#  set(NC4PAR OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{SEQ_NC_DIR} AND DEFINED ENV{SEQ_NC_CLIB})
#  set(NETCDF ON CACHE BOOL "")
#  set(NETCDF_DIR $ENV{SEQ_NC_DIR} CACHE FILEPATH "")
#  set(NETCDF_CPPFLAGS "-I${NETCDF_DIR}/include")
#  set(NETCDF_LIBS $ENV{SEQ_NC_CLIB} CACHE STRING "")
#else()
#  set(NETCDF OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{PAR_HDF5_DIR} AND DEFINED ENV{PAR_HDF5_CLIB})
#  set(PHDF5 ON CACHE BOOL "")
#  set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
#  set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#  set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
#else()
#  set(PHDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{PAR_HDF5_DIR})
  if("$ENV{PAR_HDF5_DIR}" STREQUAL "")
    set(PHDF5 OFF CACHE BOOL "")
  else()
    set(PHDF5 ON CACHE BOOL "")
    set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
    set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#   set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
  endif()
else()
  set(PHDF5 OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PORTALS_DIR})
  if("$ENV{PORTALS_DIR}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS_DIR}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
elseif(DEFINED ENV{PORTALS})
  if("$ENV{PORTALS}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
else()
  set(PORTALS OFF CACHE BOOL "")
endif()

if(DEFINED ENV{DATASPACES_INCDIR})
  if("${DATASPACES_INCDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "")
  else()
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "")
endif()
if(DEFINED ENV{DATASPACES_LIBDIR})
  if("${DATASPACES_LIBDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "" FORCE)
  else()
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "" FORCE)
endif()
if(DEFINED DATASPACES_INCDIR)
  if(DEFINED DATASPACES_LIBDIR)
    set(DATASPACES ON CACHE BOOL "" FORCE)
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE STRING "" FORCE)
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${DATASPACES}" STREQUAL "OFF")
  if(DEFINED ENV{DATASPACES_DIR})
    if(NOT "$ENV{DATASPACES_DIR}" STREQUAL "")
      set(DATASPACES ON CACHE BOOL "" FORCE)
      set(DATASPACES_DIR $ENV{DATASPACES_DIR} CACHE FILEPATH "path to dataspaces dir")
    endif()
#  set(DATASPACES_LIBS "-L$ENV{DATASPACES_DIR}/libs -ldspaces -ldscommon
#  -ldar" CACHE STRING "dataspace libs")
  else()
    if(NOT "$ENV{DATASPACES}" STREQUAL "")
      set(DATASPACES_DIR $ENV{DATASPACES} CACHE FILEPATH "path to dataspaces dir")
      set(DATASPACES ON CACHE BOOL "" FORCE)
    endif()
  endif()
endif()

if(DEFINED ENV{CRAY_PMI_DIR})
  set(CRAY_PMI_DIR $ENV{CRAY_PMI_DIR})
  if(CRAY_PMI_DIR)
    set(CRAY_PMI ON CACHE BOOL "")
    set(CRAY_PMI_LIBS_PATH "${CRAY_PMI_DIR}/lib64" CACHE STRING "")
    set(CRAY_PMI_CPPFLAGS "-I${CRAY_PMI_DIR}/include" CACHE STRING "")
  else()
    set(CRAY_PMI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_PMI OFF CACHE BOOL "")
endif()

if(DEFINED ENV{CRAY_UGNI_DIR})
  set(CRAY_UGNI_DIR $ENV{CRAY_UGNI_DIR})
  if(CRAY_UGNI_DIR)
    set(CRAY_UGNI ON CACHE BOOL "")
    set(CRAY_UGNI_LIBS_PATH "${CRAY_UGNI_DIR}/lib64" CACHE STRING "")
    set(CRAY_UGNI_CPPFLAGS "-I${CRAY_UGNI_DIR}/include")
  else()
    set(CRAY_UGNI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_UGNI OFF CACHE BOOL "")
endif()

if(DATASPACES)
  set(DIMES ON CACHE BOOL "")
else()
  set(DIMES OFF CACHE BOOL "")
endif()

if(DEFINED ENV{FLEXPATH_INCDIR})
  if("${FLEXPATH_INCDIR}" STREQUAL "")
    set(FLEXPATH OFF CACHE BOOL "")
  else()
    set(FLEXPATH_INCDIR "$ENV{FLEXPATH_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(FLEXPATH OFF CACHE BOOL "")
endif()
if(DEFINED ENV{FLEXPATH_LIBDIR})
  if("${FLEXPATH_LIBDIR}" STREQUAL "" FORCE)
    set(FLEXPATH OFF CACHE BOOL "")
  else()
    set(FLEXPATH_LIBDIR $ENV{FLEXPATH_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(FLEXPATH OFF CACHE BOOL "" FORCE)
endif()
if(DEFINED FLEXPATH_INCDIR)
  if(DEFINED FLEXPATH_LIBDIR)
    set(FLEXPATH ON CACHE BOOL "" FORCE)
    set(FLEXPATH_INCDIR "$ENV{FLEXPATH_INCDIR}" CACHE STRING "" FORCE)
    set(FLEXPATH_LIBDIR $ENV{FLEXPATH_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${FLEXPATH}" STREQUAL "OFF")
  if(DEFINED ENV{FLEXPATH_DIR})
    if(NOT "$ENV{FLEXPATH_DIR}" STREQUAL "")
      set(FLEXPATH ON CACHE BOOL "" FORCE)
      set(FLEXPATH_DIR $ENV{FLEXPATH_DIR} CACHE FILEPATH "path to flexpath dir")
    endif()
  else()
    if(NOT "$ENV{FLEXPATH_DIR}" STREQUAL "")
      set(FLEXPATH_DIR $ENV{FLEXPATH} CACHE FILEPATH "path to dataspaces dir")
      set(FLEXPATH ON CACHE BOOL "" FORCE)
    endif()
  endif()
endif()

#if(DEFINED ENV{SEQ_HDF5_DIR} AND DEFINED ENV{SEQ_HDF5_CLIB})
#  set(HDF5 ON CACHE BOOL "")
#  set(HDF5_DIR "$ENV{SEQ_HDF5_DIR}" CACHE FILEPATH "path to hdf5 dir")
#  set(HDF5_FLAGS "-I${HDF5_DIR}/include")
#  set(HDF5_LIBS "$ENV{SEQ_HDF5_CLIB}" CACHE FILEPATH "sequential hdf5")
#else()
#  set(HDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{SEQ_HDF5_DIR})
  if("$ENV{SEQ_HDF5_DIR}" STREQUAL "")
    set(HDF5 OFF CACHE BOOL "")
  else()
    set(HDF5 ON CACHE BOOL "" FORCE)
    set(HDF5_DIR "$ENV{SEQ_HDF5_DIR}" CACHE FILEPATH "path to hdf5 dir")
    set(HDF5_FLAGS "-I${HDF5_DIR}/include")
#    set(HDF5_LIBS "$ENV{SEQ_HDF5_CLIB}" CACHE FILEPATH "sequential hdf5")
  endif()
else()
  set(HDF5 OFF CACHE BOOL "")
endif()

set(DMALLOC OFF CACHE BOOL "")

if(DEFINED ENV{LUSTRE_DIR})
  set(LUSTRE_DIR "$ENV{LUSTRE_DIR}" CACHE FILEPATH "path to lustre dir")
  set(LUSTRE ON CACHE BOOL "")
else()
  set(LUSTRE OFF CACHE BOOL "")
endif()

if(DEFINED ENV{GLIB_DIR})
  if("$ENV{GLIB_DIR}" STREQUAL "")
    set(GLIB OFF CACHE BOOL "")
  else()
    set(GLIB ON CACHE BOOL "")
    set(GLIB_DIR "$ENV{GLIB_DIR}")
  endif()
elseif(DEFINED ENV{GLIB})
  if("$ENV{GLIB}" STREQUAL "")
    set(GLIB OFF CACHE BOOL "")
  else()
    set(GLIB ON CACHE BOOL "")
    set(GLIB_DIR "$ENV{GLIB}")
  endif()
endif()

if(GLIB)
  if(DEFINED ENV{FGR_DIR})
    if("$ENV{FGR_DIR}" STREQUAL "")
      set(FGR OFF CACHE BOOL "")
    else()
      set(FGR ON CACHE BOOL "")
      set(FGR_DIR "$ENV{FGR_DIR}")
    endif()
  elseif(DEFINED ENV{FGR})
    if("$ENV{FGR}" STREQUAL "")
      set(FGR OFF CACHE BOOL "")
    else()
      set(FGR ON CACHE BOOL "")
      set(FGR_DIR "$ENV{FGR}")
    endif()
  endif()
else()
  set(FGR OFF CACHE BOOL "")
endif()
 
if(DEFINED ENV{BZIP2_DIR})
  if("$ENV{BZIP2_DIR}" STREQUAL "")
    set(BZIP2 OFF CACHE BOOL "")
  else()
    set(BZIP2 ON CACHE BOOL "")
    set(BZIP2_DIR "$ENV{BZIP2_DIR}")
  endif()
elseif(DEFINED ENV{BZIP2})

=== src/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/src/core ${PROJECT_SOURCE_DIR}/src/core/transforms)
include_directories(${PROJECT_BINARY_DIR}/src)
link_directories(${PROJECT_BINARY_DIR}/src)

if(HAVE_NSSI)
  add_executable(nssi-staging-server nssi/nssi_staging_server.cpp nssi/aggregation.cpp)
  set_target_properties(nssi-staging-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL") 
  target_link_libraries(nssi-staging-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})

  add_executable(nssi-coupling-server nssi/nssi_coupling_server.cpp)
  set_target_properties(nssi-coupling-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL") 
  target_link_libraries(nssi-coupling-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})
endif(HAVE_NSSI)

set(CLEANFILES "")
set(include_HEADERS "")
set(nodist_include_HEADERS "")
set(lib_LIBRARIES "")

set(libadiosread_a_CPPFLAGS "")
set(libadiosreadf_a_CPPFLAGS "")
set(libadiosread_nompi_a_CPPFLAGS "")
set(libadiosreadf_nompi_a_CPPFLAGS "")

set(libadiosread_a_CFLAGS "")
set(libadiosreadf_a_CFLAGS "")
set(libadiosread_nompi_a_CFLAGS "")
set(libadiosreadf_nompi_a_CFLAGS "")

set (transforms_common_HDRS core/adios_copyspec.h 
                         core/adios_subvolume.h 
                         core/adios_selection_util.h 
                         core/transforms/adios_transforms_common.h 
                         core/transforms/adios_transforms_hooks.h 
                         core/transforms/adios_transforms_util.h 
                         core/adios_subvolume.h)

set (transforms_read_HDRS core/transforms/adios_transforms_transinfo.h 
                       core/transforms/adios_transforms_read.h 
                       core/transforms/adios_transforms_hooks_read.h 
                       core/transforms/adios_transforms_reqgroup.h 
                       core/transforms/adios_transforms_datablock.h
                       core/transforms/adios_patchdata.h)

set (transforms_write_HDRS  core/transforms/adios_transforms_write.h 
                        core/transforms/adios_transforms_hooks_write.h 
                        core/transforms/adios_transforms_specparse.h)

set (transforms_common_SOURCES  ${transforms_common_HDRS} 
                            core/transforms/adios_transforms_common.c 
                            core/transforms/adios_transforms_hooks.c 
                            core/adios_copyspec.c 
                            core/adios_subvolume.c 
                            core/transforms/plugindetect/detect_plugin_infos.h 
                            core/transforms/plugindetect/detect_plugin_types.h 
                            core/transforms/plugindetect/plugin_info_types.h)

set (transforms_read_SOURCES ${transforms_read_HDRS} 
                          core/transforms/adios_transforms_read.c 
                          core/transforms/adios_transforms_hooks_read.c 
                          core/transforms/adios_transforms_reqgroup.c 
                          core/transforms/adios_transforms_datablock.c 
                          core/transforms/adios_patchdata.c 
                          transforms/adios_transform_alacrity_read.c 
                          transforms/adios_transform_isobar_read.c 
                          transforms/adios_transform_aplod_read.c 
                          transforms/adios_transform_szip_read.c 
                          transforms/adios_transform_bzip2_read.c 
                          transforms/adios_transform_identity_read.c 
                          transforms/adios_transform_zlib_read.c 
                          core/adios_selection_util.c 
                          ${transforms_read_method_SOURCES})

set (transforms_write_SOURCES ${transforms_write_HDRS} 
                           core/transforms/adios_transforms_write.c 
                           core/transforms/adios_transforms_hooks_write.c 
                           core/transforms/adios_transforms_util.c 
                           core/transforms/adios_transforms_specparse.c 
                           transforms/adios_transform_alacrity_write.c
                           transforms/adios_transform_aplod_write.c
                           transforms/adios_transform_bzip2_write.c
                           transforms/adios_transform_identity_write.c
                           transforms/adios_transform_isobar_write.c
                           transforms/adios_transform_szip_write.c
                           transforms/adios_transform_zlib_write.c
                           ${transforms_write_method_SOURCES})

#start adios.a and adios_nompi.a
if(BUILD_WRITE)
    set(libadios_a_SOURCES core/adios.c 
                     core/common_adios.c
                     core/adios_internals.c
                     core/adios_internals_mxml.c 
                     core/buffer.c 
                     core/adios_bp_v1.c  
                     core/adios_endianness.c 
                     core/bp_utils.c 
                     core/futils.c 
                     core/adios_error.c 
                     core/adios_read.c 
                     core/adios_read_v1.c 
                     core/common_read.c 
                     core/globals.c 
                     core/adios_timing.c 
                     core/adios_read_hooks.c 
                     core/adios_transport_hooks.c 
                     core/adios_socket.c 
                     core/adios_logger.c 
                     core/qhashtbl.c 
                     ${transforms_common_SOURCES} 
                     ${transforms_read_SOURCES} 
                     ${transforms_write_SOURCES} 
                     core/util.c 
                     core/qhashtbl.c 
                     read/read_bp.c 
                     read/read_bp_staged.c 
                     read/read_bp_staged1.c
                     write/adios_mpi.c
                     write/adios_mpi_lustre.c
                     write/adios_mpi_amr.c
                     write/adios_posix.c
                     write/adios_posix1.c
                     write/adios_var_merge.c)

    if(HAVE_BGQ)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_mpi_bgq.c)
    endif()

    set(libadios_nompi_a_SOURCES core/adios.c 
                     core/common_adios.c 
                     core/adios_internals.c 
                     core/adios_internals_mxml.c 
                     ${transforms_common_SOURCES} 
                     ${transforms_read_SOURCES} 
                     ${transforms_write_SOURCES} 
                     core/buffer.c 
                     core/adios_bp_v1.c  
                     core/adios_endianness.c 
                     core/bp_utils.c 
                     core/futils.c 
                     core/adios_error.c 
                     core/adios_read.c 
                     core/adios_read_v1.c 
                     core/common_read.c 
                     core/globals.c 
                     core/mpidummy.c 
                     core/adios_timing.c 
                     core/adios_read_hooks.c 
                     core/adios_transport_hooks.c 
                     core/adios_socket.c 
                     core/adios_logger.c 
                     core/util.c 
                     core/qhashtbl.c 
                     read/read_bp.c 
                     read/read_bp_staged.c 
                     read/read_bp_staged1.c 
                     write/adios_posix.c 
                     write/adios_posix1.c)

#start adiosf.a and adiosf_v1.a
    if(BUILD_FORTRAN)
        set(FortranLibSources core/adiosf.c 
                       core/common_adios.c 
                       core/adios_internals.c 
                       core/adios_internals_mxml.c
                       ${transforms_common_SOURCES} 
                       ${transforms_read_SOURCES} 
                       ${transforms_write_SOURCES} 
                       core/buffer.c 
                       core/adios_bp_v1.c  
                       core/adios_endianness.c
                       core/futils.c 
                       core/adios_error.c 
                       core/bp_utils.c                
                       core/common_read.c 
                       core/globals.c 
                       core/adios_timing.c 
                       core/adios_read_hooks.c 
                       core/adios_transport_hooks.c 
                       core/adios_socket.c 
                       core/adios_logger.c 
                       core/util.c 
                       core/qhashtbl.c 
                       read/read_bp.c 
                       read/read_bp_staged.c 
                       read/read_bp_staged1.c 
                       write/adios_posix.c 
                       write/adios_posix1.c)

        set(FortranLibMPISources write/adios_mpi.c
                         write/adios_mpi_lustre.c
                         write/adios_mpi_amr.c
                         write/adios_var_merge.c)
        if(HAVE_BGQ)
            set(FortranLibMPISources ${FortranLibMPISources} write/adios_mpi_bgq.c)
        endif(HAVE_BGQ)
        set(FortranLibSEQSources core/mpidummy.c)
    endif(BUILD_FORTRAN)

    set(libadios_a_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
    set(libadios_a_CFLAGS "${ADIOSLIB_CFLAGS}")
    set(libadios_nompi_a_CPPFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_SEQ_CPPFLAGS}") 
    set(libadios_nompi_a_CFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_SEQ_CFLAGS}")
    set(libadiosf_a_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
    set(libadiosf_a_CFLAGS "${ADIOSLIB_CFLAGS}")
    set(libadiosf_nompi_a_CPPFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_SEQ_CPPFLAGS}")
    set(libadiosf_nompi_a_CFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_SEQ_CFLAGS}")

    if(HAVE_DATASPACES)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_dataspaces.c read/read_dataspaces.c)
        set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_dataspaces.c read/read_dataspaces.c)
        if(BUILD_FORTRAN)  
            set(FortranLibSources ${FortranLibSources} write/adios_dataspaces.c read/read_dataspaces.c)
        endif(BUILD_FORTRAN) 
    endif(HAVE_DATASPACES)

    if(HAVE_DIMES)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_dimes.c read/read_dimes.c)
        set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_dimes.c read/read_dimes.c)
        if(BUILD_FORTRAN)  
            set(FortranLibSources ${FortranLibSources} write/adios_dimes.c read/read_dimes.c)
        endif(BUILD_FORTRAN)
    endif(HAVE_DIMES)

    if(HAVE_DATATAP)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_datatap.c read/read_datatap.c)
        set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_datatap.c read/read_datatap.c)
        if(BUILD_FORTRAN)
            set(FortranLibSources ${FortranLibSources} write/adios_datatap.c read/read_datatap.c)
        endif(BUILD_FORTRAN)
    endif(HAVE_DATATAP)

    if(HAVE_PHDF5)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_phdf5.c)
        set(PHDF5_FLAGS "${PHDF5_FLAGS} ${MACRODEFFLAG}PHDF5 ${MACRODEFFLAG}H5_USE_16_API")
        set(libadios_a_CPPFLAGS "${libadios_a_CPPFLAGS} ${PHDF5_FLAGS}")
        if(BUILD_FORTRAN)
            set(FortranLibMPISources ${FortranLibMPISources} write/adios_phdf5.c)
            set(libadiosf_a_CPPFLAGS "${libadiosf_a_CPPFLAGS} ${PHDF5_FLAGS}")
        endif(BUILD_FORTRAN) 
    endif(HAVE_PHDF5)

    if(HAVE_NC4PAR)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_nc4.c)
        if(BUILD_FORTRAN)

=== utils/CMakeLists.txt ===
add_subdirectory(gpp)
add_subdirectory(bpdump)
add_subdirectory(bp2ascii)
add_subdirectory(bpsplit)
add_subdirectory(bpls)
add_subdirectory(bpdiff)
add_subdirectory(list_methods)

if(BUILD_WRITE)
  add_subdirectory(adios_lint)
  add_subdirectory(bp2bp)
endif(BUILD_WRITE)

if(HAVE_HDF5)
  add_subdirectory(bp2h5)
endif(HAVE_HDF5)

if(HAVE_NETCDF)
  add_subdirectory(bp2ncd)
endif(HAVE_NETCDF)

add_subdirectory(skel)
add_subdirectory(skeldump)

#find_library(ADIOS_INTERNAL_NOMPI_LIB adios_internal_nompi ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_INTERNAL_NOMPI_LIB}-NOTFOUND)
#  message(STATUS "cannot find adios_internal_nompi.a in ${PROJECT_SOURCE_DIR}/utils")
#endif(${ADIOS_INTERNAL_NOMPI_LIB}-NOTFOUND)

#find_library(ADIOSREAD_NOMPI_LIB adiosread_nompi ${PROJECT_BINARY_DIR}/src)
#if(${ADIOSREAD_NOMPI_LIB}-NOTFOUND)
#  message(STATUS "cannot find adiosread_nompi.a in ${PROJECT_SOURCE_DIR}/utils")
#endif(${ADIOSREAD_NOMPI_LIB}-NOTFOUND)

#find_library(ADIOS_LIB adios ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_LIB}-NOTFOUND)
#  message(STATUS "cannot find adios.a in ${PROJECT_SOURCE_DIR}/utils makefile")
#endif(${ADIOS_LIB}-NOTFOUND)

=== tests/C/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/tests/C)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src)
link_directories(${PROJECT_BINARY_DIR}/src)
link_directories(${MXML_INCLUDE_DIR}/../lib)

add_executable(adios_test_c adios_test_c.c)
target_link_libraries(adios_test_c adios ${ADIOSLIB_LDADD} ${MPI_C_LIBRARIES}) 
set(adios_test_c_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
set(adios_test_c_CFLAGS "${ADIOSLIB_CFLAGS}")
set_target_properties(adios_test_c PROPERTIES COMPILE_FLAGS "${adios_test_c_CFLAGS} ${adios_test_c_CPPFLAGS} ${MPI_C_COMPILE_FLAGS}")
if(MPI_LINK_FLAGS)
   set_target_properties(adios_test_c PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()

file(COPY config_c.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/C)

add_subdirectory(flexpath_tests)

=== tests/Fortran/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/tests/Fortran)
link_directories(${PROJECT_BINARY_DIR}/tests/Fortran)

add_executable(adios_test_f adios_test_f.F90)
target_link_libraries(adios_test_f adiosf ${ADIOSLIB_LDADD})
set_target_properties(adios_test_f PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

file(COPY config_fortran.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/Fortran)

=== tests/bp_read/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/tests/bp_read)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src)
link_directories(${PROJECT_BINARY_DIR}/tests/bp_read)

set(genbp_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
set(genbp_CFLAGS "${ADIOSLIB_CFLAGS}")

set(bp_read_c_CPPFLAGS "-DADIOS_USE_READ_API_1 ${ADIOSLIB_CPPFLAGS}")
set(bp_read_c_CFLAGS "${ADIOSLIB_CFLAGS}")

add_executable(genbp genbp.c)
target_link_libraries(genbp adios adiosread ${ADIOSLIB_LDADD} ${MPI_C_LIBRARIES}) 
set_target_properties(genbp PROPERTIES COMPILE_FLAGS "${genbp_CPPFLAGS} ${genbp_CFLAGS} ${MPI_C_COMPILE_FLAGS}")
if(MPI_LINK_FLAGS)
   set_target_properties(genbp PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()

add_executable(bp_read_c bp_read_c.c)
target_link_libraries(bp_read_c adiosread ${ADIOSREADLIB_LDADD} ${MPI_C_LIBRARIES})
set_target_properties(bp_read_c PROPERTIES COMPILE_FLAGS "${bp_read_c_CPPFLAGS} ${bp_read_c_CFLAGS}")

if(BUILD_FORTRAN)
  add_executable(bp_read_f bp_read_f.F90)
  target_link_libraries(bp_read_f adiosreadf ${ADIOSREADLIB_LDADD})
  set(bp_read_f_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
  set(bp_read_f_CFLAGS "${ADIOSLIB_CFLAGS}")
  set_target_properties(bp_read_f PROPERTIES COMPILE_FLAGS "${bp_read_f_CPPFLAGS} ${bp_read_f_CFLAGS}")

  add_executable(bp_read_f_v1 bp_read_f_v1.F90)
  target_link_libraries(bp_read_f_v1 adiosreadf_v1 ${ADIOSREADLIB_LDADD})
  set(bp_read_f_v1_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
  set(bp_read_f_v1_CFLAGS "${ADIOSLIB_CFLAGS}")
  set_target_properties(bp_read_f_v1 PROPERTIES COMPILE_FLAGS "${bp_read_f_v1_CPPFLAGS} ${bp_read_f_v1_CFLAGS}")

endif(BUILD_FORTRAN)

file(COPY testbp_c.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/bp_read)

=== tests/genarray/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/tests/genarray)
include_directories(${PROJECT_BINARY_DIR}/tests/genarray)
link_directories(${PROJECT_BINARY_DIR}/tests/genarray)

add_executable(genarray genarray.F90 gwrite_genarray.fh)
target_link_libraries(genarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(genarray2D genarray2D.F90)
target_link_libraries(genarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray copyarray.F90 gread_genarray.fh)
target_link_libraries(copyarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray2D copyarray2D.F90)
target_link_libraries(copyarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_custom_command(
	OUTPUT gwrite_genarray.fh
	COMMAND rm -f gwrite_genarray.fh gread_genarray.fh 
	COMMAND ${PROJECT_SOURCE_DIR}/utils/gpp/gpp.py ${PROJECT_SOURCE_DIR}/tests/genarray/genarray3d.xml
	DEPENDS genarray3d.xml
	)

add_custom_command(
        OUTPUT gread_genarray.fh 
	COMMAND rm -f gwrite_genarray.fh gread_genarray.fh 
	COMMAND ${PROJECT_SOURCE_DIR}/utils/gpp/gpp.py ${PROJECT_SOURCE_DIR}/tests/genarray/genarray3d.xml
	DEPENDS genarray3d.xml
	)

file(COPY genarray.xml genarray3d.xml job.ewok job2D.ewok DESTINATION ${PROJECT_BINARY_DIR}/tests/genarray)

=== tests/suite/CMakeLists.txt ===
add_subdirectory(programs)

file(COPY HOWTO-Add-new-test HOWTO-Run cleanup.sh test.sh DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)

if(EXISTS ${PROJECT_BINARY_DIR}/tests/suite/reference)
  file(COPY reference/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/reference)
else()
  file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/suite/reference)
  file(COPY reference/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/reference)
endif()

if(EXISTS ${PROJECT_BINARY_DIR}/tests/suite/tests)
  file(COPY tests/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/tests)
else()
  file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/suite/tests)
  file(COPY tests/ DESTINATION ${PROJECT_BINARY_DIR}/tests/suite/tests)
endif()

#install(PROGRAMS cleanup.sh DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)
#install(DIRECTORY reference USE_SOURCE_PERMISSIONS DESTINATION ${PROJECT_BINARY_DIR}/tests/suite PATTERN ".svn" EXCLUDE)
#install(PROGRAMS test.sh DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)
#install(DIRECTORY tests USE_SOURCE_PERMISSIONS DESTINATION ${PROJECT_BINARY_DIR}/tests/suite PATTERN ".svn" EXCLUDE)

=== utils/bp2bp/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/utils/bp2bp)
link_directories(${PROJECT_BINARY_DIR}/utils/bp2bp)

add_executable(bp2bp bp2bp.c)
target_link_libraries(bp2bp adios ${ADIOSLIB_LDADD} ${MPI_C_LIBRARIES})
set_target_properties(bp2bp PROPERTIES COMPILE_FLAGS "${MACRODEFFLAG}ADIOS_USE_READ_API_1 ${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${MPI_C_COMPILE_FLAGS}")

if(MPI_LINK_FLAGS)
   set_target_properties(bp2bp PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()

install(PROGRAMS ${PROJECT_BINARY_DIR}/utils/bp2bp/bp2bp DESTINATION ${bindir})

=== utils/bp2h5/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/utils/bp2h5)
link_directories(${PROJECT_BINARY_DIR}/utils/bp2h5)

add_executable(bp2h5 bp2h5.c)
if(USE_PARALLEL_COMPILER)
  target_link_libraries(bp2h5 adiosread ${ADIOSREADLIB_LDADD} ${HDF5_LIBS})
  set_target_properties(bp2h5 PROPERTIES COMPILE_FLAGS "${MACRODEFFLAG}H5_USE_16_API ${MACRODEFFLAG}ADIOS_USE_READ_API_1 ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSREADLIB_CPPFLAGS} ${ADIOSREADLIB_CFLAGS} ${HDF5_FLAGS}")
else()
  target_link_libraries(bp2h5 adiosread_nompi ${ADIOSREADLIB_SEQ_LDADD} ${HDF5_LIBS})
  set_target_properties(bp2h5 PROPERTIES COMPILE_FLAGS "${MACRODEFFLAG}H5_USE_16_API ${MACRODEFFLAG}ADIOS_USE_READ_API_1 ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSREADLIB_SEQ_CPPFLAGS} ${HDF5_FLAGS}")
endif()

install(PROGRAMS ${PROJECT_BINARY_DIR}/utils/bp2h5/bp2h5 DESTINATION ${bindir})

=== utils/bp2ncd/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_SOURCE_DIR}/utils/bp2ncd)
include_directories(${PROJECT_BINARY_DIR})
link_directories(${PROJECT_BINARY_DIR}/utils/bp2ncd)

add_executable(bp2ncd bp2ncd.c)

if(USE_PARALLEL_COMPILER)
  set(bp2ncd_CPPFLAGS "${NETCDF_CPPFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
  set(bp2ncd_CFLAGS "${NETCDF_CFLAGS} ${ADIOSLIB_CFLAGS}")
  target_link_libraries(bp2ncd adios ${ADIOSLIB_LDADD})
  set_target_properties(bp2ncd PROPERTIES COMPILE_FLAGS "${bp2ncd_CPPFLAGS} ${bp2ncd_CFLAGS}")
else(USE_PARALLEL_COMPILER)
  set(bp2ncd_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_INT_CPPFLAGS} ${ADIOSLIB_INT_CFLAGS}")
  target_link_libraries(bp2ncd adios_internal_nompi ${ADIOSLIB_INT_LDADD})
  set_target_properties(bp2ncd PROPERTIES COMPILE_FLAGS "${bp2ncd_CPPFLAGS}")
endif(USE_PARALLEL_COMPILER)

#install(FILES bp2ncd.h DESTINATION ${PROJECT_BINARY_DIR}/utils/bp2ncd)
install(PROGRAMS ${PROJECT_BINARY_DIR}/utils/bp2ncd/bp2ncd DESTINATION ${bindir})

=== utils/bpdiff/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/utils/bpdiff)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
link_directories(${PROJECT_BINARY_DIR}/utils/bpdiff)

add_executable(bpdiff bpdiff.c decompose_block.c utils.c)
target_link_libraries(bpdiff adiosread_nompi ${ADIOSREADLIB_LDADD})
set_target_properties(bpdiff PROPERTIES COMPILE_FLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSREADLIB_CPPFLAGS} ${ADIOSREADLIB_CFLAGS}")

install(PROGRAMS ${CMAKE_BINARY_DIR}/utils/bpdiff/bpdiff DESTINATION ${bindir})

=== debian/changelog ===
adios (1.7.0-4) unstable; urgency=medium

  * Provide FindADIOS in cmake 3.0 path. Closes: #758546.
  * Rebuild with new gfortran. Closes: #751248.
  * Split examples into separate package. Closes: #732276.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 12 Sep 2014 08:35:19 +0100

adios (1.7.0-3) unstable; urgency=low

  [ Gilles Filippini ]
  * Support hdf5 1.8.13 new packaging layout. Closes: #756647.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 01 Aug 2014 11:53:10 +0100

adios (1.7.0-2) unstable; urgency=medium

  * PATH not inherited correctly. export it.
  * Cope with python3.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 17 Jun 2014 08:45:36 +0100

adios (1.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Add adios.pc pkgconfig file. adios_config now uses this.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Jun 2014 23:06:38 +0100

adios (1.6.0-7) unstable; urgency=medium

  * Use python3-all-dev to build on all python3 versions.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 May 2014 03:02:48 +0100

adios (1.6.0-6) unstable; urgency=medium

  * Fix typo that broke build of python2.7 wrapper. Closes: #749009.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 22 May 2014 11:58:23 +0100

adios (1.6.0-5) unstable; urgency=medium

  * Don't depend on infiniband on hurd, kfreebsd-*
  * Build with serial HDF5 by default; building with mpicc.openmpi collides
    with mpipublic.h internally.
  * Prime CMakeCache.txt with PYTHON_MPI4PY_INCLUDE_DIR so it is found
    on all archs to fix FTBFS.
  * Add initial bash_completion.d completions.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 22 May 2014 07:02:04 +0100

adios (1.6.0-4) unstable; urgency=medium

  * Add python-adios, python3-adios wrapper packages.
  * Add infiniband, bzip2, libz as 'transports'

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 May 2014 15:05:17 +0100

adios (1.6.0-3) unstable; urgency=medium

  * Ensure makefile doesn't fail on shell conditional in debian/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 28 Mar 2014 21:36:36 +0000

adios (1.6.0-2) unstable; urgency=medium

  * Disable tests on big-endian platforms due to upstream test bug.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 28 Mar 2014 18:38:22 +0000

adios (1.6.0-1) unstable; urgency=medium

  * New upstream. Closes: #732276, #727312.
  * Ship in xz format. 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 18 Feb 2014 00:36:53 +0000

=== debian/control ===
Source: adios
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), libnetcdf-dev, gfortran, libhdf5-dev, libmxml-dev, 
  mpi-default-dev, autotools-dev, cmake, libbz2-dev, zlib1g-dev, dh-autoreconf,
  libibverbs-dev [ !hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  python-dev, python-numpy, python-mpi4py, cython, dh-python,
  python3-all-dev, python3-numpy, python3-mpi4py, cython3
Standards-Version: 3.9.5
Homepage: http://www.olcf.ornl.gov/center-projects/adios/
X-Python-Version: 2.7
X-Python3-Version: 3.3+

Package: libadios-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:  ${misc:Depends}, ${shlibs:Depends}
Recommends: libadios-bin, libadios-examples
Description: ADIOS Adaptable IO system for simulations
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.


Package: libadios-examples
Architecture: any
Depends:  ${misc:Depends}, ${shlibs:Depends}
Recommends: libadios-dev
Description: ADIOS Adaptable IO system for simulations - exampes
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .
 This package contains examples for ADIOS.

Package: libadios-bin
Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Architecture: any
Multi-Arch: foreign
Recommends: libadios-dev
Description: ADIOS Adaptable IO system for simulations - binaries
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .
 This package provides tools for use with ADIOS.

Package: python-adios
Depends: ${python:Depends}, ${misc:Depends}, ${shlibs:Depends}
Section: python
Architecture: any
Multi-Arch: same
Provides: ${python:Provides}
Description: Python interace to the ADIOS IO system
 This is a Python2 interface to ADIOS.
 .
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .

Package: python3-adios
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Section: python
Architecture: any
Multi-Arch: same
Provides: ${python:Provides}
Description: Python3 interace to the ADIOS IO system
 This is a Python3 interface to ADIOS.
 .
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# Cope with lam not providing mpicc.
include /usr/share/mpi-default-dev/debian_defaults
ifeq ($(ARCH_DEFAULT_MPI_IMPL),lam)
  CC:=mpicc.lam
  CXX:=mpicc.lam
else
  CC:=mpicc
  CXX:=mpic++
endif

ARCH:=$(shell dpkg --print-architecture)
WITH_LUSTRE :=
WITH_IBVERBS:= --with-ibverbs=/usr
DO_TEST:= true

# Do tests on little-endian only for the moment;
# lustre currently not provided in Debian sid

ifeq ($(ARCH), i386)
#  WITH_LUSTRE:= --with-lustre=/usr
endif
ifeq ($(ARCH), amd64)
#  WITH_LUSTRE:= --with-lustre=/usr
endif
ifeq ($(ARCH), powerpc)
#  WITH_LUSTRE:= --with-lustre=/usr
   DO_TEST:= false
endif
ifeq ($(ARCH), ia64)
#  WITH_LUSTRE:= --with-lustre=/usr
endif
ifeq ($(ARCH), sparc)
   DO_TEST:= false
endif
ifeq ($(ARCH), mips)
   DO_TEST:= false
endif
ifeq ($(ARCH),hurd-i386)
  WITH_IBVERBS:=
endif
ifeq ($(ARCH),kfreebsd-amd64)
  WITH_IBVERBS:=
endif
ifeq ($(ARCH),kfreebsd-i386)
  WITH_IBVERBS:=
endif

# Temporary, allowing hdf5 transition. Before jessie release,
# (when netcdf has transitioned to multiple hdf5), allow both
#  serial and mpi versions of ADIOS libraries
ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  WITH_HDF5:=--with-hdf5=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
else
  WITH_HDF5:=--with-hdf5=/usr
endif

DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
BINDIR:=$(DESTDIR)/usr/bin
PY2:=python2.7
PY3VERS:= $(shell py3versions -s)

TOP:=$(shell pwd)
export PATH:=$(TOP):$(PATH)

# magic debhelper rule
%:
	dh $@ --with autoreconf,autotools_dev,python2,python3

override_dh_auto_clean:
	dh_clean
	find . -name '*.pyc' -delete
	rm -fr wrappers/numpy/build wrappers/java/build debian/tmpp
	# Remove dodgy symlink
	rm -f ./examples/staging/stage_write/writer_adios

override_dh_auto_configure:
	dh_auto_configure --  $(WITH_LUSTRE) $(WITH_IBVERBS) --enable-shared \
		$(WITH_HDF5) --with-bzip2=/usr  --with-zlib=/usr \
		--prefix=$(DESTDIR) MPIFC=mpif77 CC=$(CC) # CFLAGS='-fPIC'

override_dh_auto_build:
	# First do a build shared, with -fPIC, for the python lib.
	$(MAKE) -C src CFLAGS='-fPIC' VERBOSE=1 install
	# Need to hack the libs into the right place, to match adios_configs view
	mv debian/tmp/lib/*/*.a debian/tmp/lib
	# Now build Python wrapper. Uses adios_config and the debian/tmp install.
	for p in ${PY2} ${PY3VERS} ; do \
		( cd wrappers/numpy && \
		    $$p ./setup.py     install --prefix=$(TOP)/debian/tmpp  ;\
			$$p ./setup_mpi.py install --prefix=$(TOP)/debian/tmpp ) ; done
	# Clean up.
	rm -r debian/tmp/*
	# Now do the static build we want.
	dh_auto_build

override_dh_auto_install:
	find . -name .gitignore -delete
	$(MAKE) install prefix=$(DESTDIR)/usr
	install -D -m 644  adios.pc $(TOP)/debian/tmp/$(LIBDIR)/pkgconfig
	# Sort python stuff
	mkdir -p $(TOP)/debian/tmp/usr/lib/python3/dist-packages
	mkdir -p $(TOP)/debian/tmp/usr/lib/${PY2}/dist-packages
	for p in $(PY3VERS); do \
		v=`echo $$p | cut -c7,9` ;\
		CYV=cpython-$${v}m ;\
		mv $(TOP)/debian/tmpp/lib/$${p}/site-packages/adios.$${CYV}.so \
			debian/tmp/usr/lib/python3/dist-packages/adios.$${CYV}-${DEB_HOST_MULTIARCH}.so  ; \
		mv $(TOP)/debian/tmpp/lib/$${p}/site-packages/adios_mpi.$${CYV}.so \
			debian/tmp/usr/lib/python3/dist-packages/adios_mpi.$${CYV}-${DEB_HOST_MULTIARCH}.so  ; \
	done
	mv $(TOP)/debian/tmpp/lib/${PY2}/site-packages/adios_mpi.so \
		debian/tmp/usr/lib/${PY2}/dist-packages/adios_mpi.${DEB_HOST_MULTIARCH}.so
	mv $(TOP)/debian/tmpp/lib/${PY2}/site-packages/adios.so \
		debian/tmp/usr/lib/${PY2}/dist-packages/adios.${DEB_HOST_MULTIARCH}.so
	rm -r debian/tmpp
	# remove due to it not working in multi-arch;
	rm -f  $(BINDIR)/adios_config.flags
	# renamed as per Adios CCS issue #118716, Debbug #639257
	mv $(BINDIR)/gpp.py $(BINDIR)/adiosxml2h
	mv $(BINDIR)/ad_config.py $(BINDIR)/ad_config
	mv $(BINDIR)/skel_cat.py $(BINDIR)/skel_cat
	mv $(BINDIR)/skel_extract.py $(BINDIR)/skel_extract
	cp debian/adios_config $(BINDIR)/adios_config
	# mv $(DESTDIR)/bin/xmlparser.py $(DESTDIR)/bin/xmlparser

override_dh_auto_test:
	$(DO_TEST) && $(MAKE) check || echo "Tests disabled on bigendian systems for the moment"

override_dh_installexamples:
	dh_installexamples
	find debian/libadios-examples/usr/share/doc/libadios-examples/examples -name '*.o' -delete
	find debian/libadios-examples/usr/share/doc/libadios-examples/examples/C -type f -exec chmod -x {} \;

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/libadios-bin/etc/adios/skel/templates/*.tpl
	chmod -x debian/libadios-bin/etc/adios/skel/templates/*.tmpl
